import _asyncToGenerator from "@babel/runtime/helpers/asyncToGenerator";
import _regeneratorRuntime from "@babel/runtime/regenerator";
import _ from 'lodash'; // eslint-disable-line

import chalk from 'chalk'; // eslint-disable-line

import path from 'path';
import writeFiles from './writeFiles';
import createServerModel from '../templates/server/model';
import createServerController from '../templates/server/controller';
import createServerTemplate from '../templates/server/template';
import createSharedModel from '../templates/shared/models/model';
import createSharedSchema from '../templates/shared/models/schema';
import createActions from '../templates/shared/module/actions';
import createReducer from '../templates/shared/module/reducer';
import createSelectors from '../templates/shared/module/selectors';
import createForm from '../templates/shared/module/components/forms/ExampleModelForm';
import createModelCreate from '../templates/shared/module/components/ExampleModelCreate';
import createModelDetail from '../templates/shared/module/components/ExampleModelDetail';
import createModelEdit from '../templates/shared/module/components/ExampleModelEdit';
import createModelList from '../templates/shared/module/components/ExampleModelList';
import createModelCreateContainer from '../templates/shared/module/containers/ExampleModelCreate';
import createModelDetailContainer from '../templates/shared/module/containers/ExampleModelDetail';
import createModelEditContainer from '../templates/shared/module/containers/ExampleModelEdit';
import createModelListContainer from '../templates/shared/module/containers/ExampleModelList';
export default function generateModuleFiles(_x, _x2) {
  return _generateModuleFiles.apply(this, arguments);
}

function _generateModuleFiles() {
  _generateModuleFiles = _asyncToGenerator( /*#__PURE__*/_regeneratorRuntime.mark(function _callee(model, options) {
    var output;
    return _regeneratorRuntime.wrap(function _callee$(_context) {
      while (1) {
        switch (_context.prev = _context.next) {
          case 0:
            output = [{
              path: path.join(options.root, "server/models/".concat(model.className, ".js")),
              content: createServerModel(model)
            }, {
              path: path.join(options.root, "server/api/controllers/".concat(model.classPlural, ".js")),
              content: createServerController(model)
            }, {
              path: path.join(options.root, "server/api/templates/".concat(model.variablePlural, "/base.js")),
              content: createServerTemplate(model)
            }, {
              path: path.join(options.root, "shared/models/".concat(model.className, ".js")),
              content: createSharedModel(model)
            }, {
              path: path.join(options.root, "shared/models/schemas/".concat(model.variableName, ".js")),
              content: createSharedSchema(model)
            }, {
              path: path.join(options.root, "shared/modules/".concat(model.variablePlural, "/actions.js")),
              content: createActions(model)
            }, {
              path: path.join(options.root, "shared/modules/".concat(model.variablePlural, "/reducer.js")),
              content: createReducer(model)
            }, {
              path: path.join(options.root, "shared/modules/".concat(model.variablePlural, "/selectors.js")),
              content: createSelectors(model)
            }, {
              path: path.join(options.root, "shared/modules/".concat(model.variablePlural, "/components/forms/").concat(model.className, "Form.js")),
              content: createForm(model)
            }, {
              path: path.join(options.root, "shared/modules/".concat(model.variablePlural, "/components/").concat(model.className, "Create.js")),
              content: createModelCreate(model)
            }, {
              path: path.join(options.root, "shared/modules/".concat(model.variablePlural, "/components/").concat(model.className, "Detail.js")),
              content: createModelDetail(model)
            }, {
              path: path.join(options.root, "shared/modules/".concat(model.variablePlural, "/components/").concat(model.className, "Edit.js")),
              content: createModelEdit(model)
            }, {
              path: path.join(options.root, "shared/modules/".concat(model.variablePlural, "/components/").concat(model.className, "List.js")),
              content: createModelList(model)
            }, {
              path: path.join(options.root, "shared/modules/".concat(model.variablePlural, "/containers/").concat(model.className, "Create.js")),
              content: createModelCreateContainer(model)
            }, {
              path: path.join(options.root, "shared/modules/".concat(model.variablePlural, "/containers/").concat(model.className, "Detail.js")),
              content: createModelDetailContainer(model)
            }, {
              path: path.join(options.root, "shared/modules/".concat(model.variablePlural, "/containers/").concat(model.className, "Edit.js")),
              content: createModelEditContainer(model)
            }, {
              path: path.join(options.root, "shared/modules/".concat(model.variablePlural, "/containers/").concat(model.className, "List.js")),
              content: createModelListContainer(model)
            }];
            _context.next = 3;
            return writeFiles(output, options);

          case 3:
          case "end":
            return _context.stop();
        }
      }
    }, _callee);
  }));
  return _generateModuleFiles.apply(this, arguments);
}