/* eslint-disable no-bitwise */
import fs from 'fs';
import { promisify } from 'util';

function replaceString(fileName, oldStr, newStr, callback) {
  fs.access(fileName, fs.W_OK | fs.R_OK, function (err) {
    if (err) return callback(new Error("String replacement failure: ".concat(err)));
    fs.readFile(fileName, function (err, data) {
      //read old file
      if (err) return callback(new Error("String replacement failure: ".concat(err)));
      var txt = data.toString();
      var replacedTxt = txt.replace(oldStr, newStr);
      fs.writeFile(fileName + '_tmp', replacedTxt, function (err) {
        //write tmp file
        if (err) return callback(new Error("String replacement failure: ".concat(err)));
        fs.unlink(fileName, function (err) {
          //delete old file
          if (err) return callback(new Error("String replacement failure: ".concat(err)));
          fs.rename(fileName + '_tmp', fileName, function (err) {
            // rename tmp file
            if (err) return callback(new Error("String replacement failure: ".concat(err)));
            return callback(null);
          });
        });
      });
    });
  });
}

export default promisify(replaceString);